/********************************************************************
*                                                                   *
*       MODULE  NAME    :	Hard Copy   Procedure                   *
*       FILE    NAME    :	gamen02.c                                *
*                                                                   *
*       DECRIPTION      :                                           *
*                                                                   *
*       CREATE          :   1993/08/09  Ver 3.0     Y.Fukuyama      *
*       UPDATE          :   1993/xx/xx                              *
*                                                                   *
*********************************************************************/

#include	<TK2/TK.h>
#include	<TK2/TKusr.h>
#ifdef PS
#include	<PRkid/TKPrinPS.h>
#endif
#include	<GR.h>
#include    "gamen02.h"
#include    "gamen10.h"
#include    "gamen11.h"

	extern	int		graph_no;

	extern	Ktroot	*root;

	int		pr_hc_end();

	Ktcore	*core_hc = NULL;

	typedef	struct
	{
		char	*printer;
		char	*lpr;
		int		delete;
		int		size;
		int		type;
		float	*zoomx;
		float	*zoomy;
		int		*margn_left;
		int		*margn_up;
		char	*file;
	}ST_PRIN_INF;

	ST_PRIN_INF		bf_prin_inf;
	char			*pt_print_msg_on;
	char			*pt_print_msg_off;

/*$*/
/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_initial( )
{
	bf_prin_inf.printer		= (char *)tb_hc_in_prn.data;
	bf_prin_inf.lpr			= (char *)tb_hc_in_lpr.data;
	bf_prin_inf.delete		= tb_hc_sel_undel.bid;
	bf_prin_inf.type		= tb_hc_sel_tate.bid;
	bf_prin_inf.zoomx		= (float *)tb_hc_in_zoomx.data;
	bf_prin_inf.zoomy		= (float *)tb_hc_in_zoomy.data;
	bf_prin_inf.margn_left	= (int *)tb_hc_in_margn_left.data;
	bf_prin_inf.margn_up	= (int *)tb_hc_in_margn_up.data;
	bf_prin_inf.file		= (char *)tb_hc_in_file.data;

#ifdef LP
	strcpy( tb_hc_in_lpr.data, "lp -d" );
#endif
#ifdef LPR
	strcpy( tb_hc_in_lpr.data, "lpr -P" );
#endif
	strcpy( tb_hc_in_file.data,"DEMOPRN" );
	*bf_prin_inf.zoomx = 100.0;
	*bf_prin_inf.zoomy = 100.0;

	tb_hc_sel_tate.flg = ON;
	tb_hc_sel_undel.flg = ON;

	pt_print_msg_off = tb_hc_exec.sym;
	pt_print_msg_on  = "";

	return(0);
}
/*$*/
/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_start( core )

	Ktcore	*core;
{
	int		sts = 0;


	if( core_hc == NULL )
	{
		pr_panel_center( &panel_hardcopy );
		core_hc = (Ktcore *)TKopen( root, core->kit, &panel_hardcopy );
		if( core_hc != NULL )
		{
			TKnotify( core_hc, KEXIT, pr_hc_end );
			TKentry( core_hc, KARRAY, panel_hardcopy_tree );
		}
	}
	return( sts );
}

/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_end( core )
	Ktcore	*core;
{
	core_hc = NULL;

	return( 0 );
}
/*$*/
/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_sel_size( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		pr_other_button_off( core, tb_hc_size_tree, button );
	}

	return( sts );
}

/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_sel_type( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		pr_other_button_off( core, tb_hc_type_tree, button );

		bf_prin_inf.type = button->bid;
	}

	return( sts );
}

/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_sel_delete( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		pr_other_button_off( core, tb_hc_delete_tree, button );

		bf_prin_inf.delete = button->bid;
	}

	return( sts );
}

/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_sel_off( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;


	if( event == ButtonPress )
	{
		button->flg = ON;
		TKdisplay( core, KSINGL, button );
	}

	return( sts );
}

/********************************************************************
*   FUNCTION NAME   :                                               *
*-------------------------------------------------------------------*
*   IN  PARAMETER   :                                               *
*   OUT PARAMETER   :                                               *
*********************************************************************/

int		pr_hc_exec( core, button, event )
	Ktcore	*core;
	Ktbutn	*button;
	int		event;
{
	int		sts = 0;
	static char	env[80];
	int		i;


	if( event == ButtonPress )
	{
		button->sym = pt_print_msg_on;
		TKdisplay( core, KSINGL, button );
		TKsync( core );

		TKkeyoff( core );

#if 0
		pr_in_str_space( 0, tb_hc_in_prn.data );
		pr_in_str_space( 0, bf_prin_inf.lpr );
		pr_in_str_space( 0, bf_prin_inf.file );
#endif

		if( tb_hc_in_prn.data[0] == 0 )
		{
			bf_prin_inf.printer = NULL;
		}else
		{
			bf_prin_inf.printer = (char *)tb_hc_in_prn.data;
		}

		if( ( bf_prin_inf.printer != NULL ) &&
			( bf_prin_inf.lpr[0] == 0 ) )
		{
#if 0
			pr_error_message( core, root, "ץ󥿡ޥɤꤵƤޤ" );
#else
			putc( 7, stderr );
#endif
			TKkeysw( core, &tb_hc_in_lpr, KION, -1, -1 );
		}else if( bf_prin_inf.file[0] == 0 )
		{
#if 0
			pr_error_message( core, root, "ȥե̾ꤵƤޤ" );
#else
			putc( 7, stderr );
#endif
			TKkeysw( core, &tb_hc_in_file, KION, -1, -1 );
		}else
		{
#ifdef PS
			TKpinit(	 NULL,
						 bf_prin_inf.type,
						*bf_prin_inf.zoomx,
						*bf_prin_inf.zoomy,
						*bf_prin_inf.margn_left,
						*bf_prin_inf.margn_up,
						 bf_prin_inf.file		);
			TKpsetcolorspace(KSGRAY);

#if 0
			TKpinit2( &panel10, KSPANELON, KSPNLSIZE );
			TKprint( KARRAY, panel10_tree );
			for(i=0; tb_fukugou_bars1[i]!=NULL; i++)
				TKprint( KARRAY, tb_fukugou_bars1[i]->hed.ent );
			for(i=0; tb_fukugou_bars2[i]!=NULL; i++)
				TKprint( KARRAY, tb_fukugou_bars2[i]->hed.ent );
			TKprint( KARRAY, oresen.hed.ent );
#endif
			switch( graph_no )
			{
				case 1:
					pr_fukugou_printPS();
					break;
				case 2:
					pr_wari_printPS();
					break;
				case 3:
					pr_pay_printPS();
					break;
				case 4:
					pr_uri_printPS();
					break;
			}
			sprintf( env, "PRkidlp=%s", bf_prin_inf.lpr );
			putenv( env );
			TKpout(	bf_prin_inf.printer, bf_prin_inf.delete, 1 );
#endif
		}

		button->sym = pt_print_msg_off;
		TKdisplay( core, KSINGL, button );
		TKsync( core );
	}

	return( sts );
}
