/********************************************/
/*											*/
/*      F.D.S ToolKit structure define      */
/*											*/
/********************************************/

#ifndef _TK_H_
#define _TK_H_

#ifndef	G200
#ifndef caddr_t
#ifndef __TYPES__
#define __TYPES__
#include <sys/types.h>
#endif
#endif
#endif
#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
#include <ctype.h>
#include <sys/file.h>
#include <fcntl.h>

#include "Q.h"
#include "TKdef.h"

#ifdef SVR4
#define	SVR2	1
#endif
#ifdef SVR2
#include "TKsysv.h"
#endif

/*  ToolKit infomation data  */

typedef	struct	{				/* Toolkit bitmap iinfomation		*/
	int		type;				/* bitmap data type					*/
	int		w,h;				/* bitmap width, height				*/
	int		hx,hy;				/* bitmap hot spot x, y				*/
	char	*data;				/* bitmap file name or data			*/
}	Ktbitmap;

typedef struct  {				/* ToolKit core Font infomation		*/
    int     flg;				/* ank or kanji flag				*/
    Font    fid;				/* Font ID							*/
    int     w,h;				/* Font size						*/
    int     ox,oy;				/* Font display offset				*/
	XFontStruct	*finf;			/* Font structure					*/
	char	*name;
}   Ktfinf;

typedef struct  {				/* ToolKit object header			*/
    int     type;				/* object type						*/
    QID     id;					/* chain ID							*/
    int     flag;				/* display flag						*/
}   Ktobj;

typedef struct  {               /* ToolKit panel titlebar infomation*/
    Ktobj   *clos;              /* panel close button               */
    Ktobj   *titl;              /* title bar                        */
    Ktobj   *icon;              /* icon button                      */
}   Kttitl;

typedef struct  {				/* ToolKit root infomation			*/
    Display *dis;				/* X server connection				*/
    int     scr;				/* X screen							*/
	int		dep;				/* X depth							*/
	Window	root;				/* root window id					*/
	int		rw,rh;				/* root window size					*/
	Visual	*vis;				/* X visual							*/
    Colormap cmap;				/* X Colormap						*/
    GC      gc;					/* X GC								*/
    Pixmap  *ptn;				/* ToolKit pattern pixmap			*/
    Ktfinf  *fnt;				/* ToolKit Font infomation			*/
	XColor	*color;				/* Toolkit color data				*/
	char	*cname;				/* Toolkit color name				*/
	int		ncolor;				/* Toolkit color count				*/
    CQcnt   panel;				/* panel chain						*/
    QID     input;				/* curent keyinput event			*/
	int		*incore;			/* keyinput core					*/
	int		*key;				/* user define key code	infomation	*/
	int		*val;				/* Graphic attributes				*/
	int		*xim;				/* XIM infomation					*/
	int		*jct;				/* Japanese infomation				*/
	int		id;					/* root id							*/
	int		im;					/* input mode						*/
	int		*acore;				/* Past area core					*/
	int		*aobj;				/* Past object						*/
	int		pm;					/* Past mode						*/
}   Ktroot;

typedef struct  {				/* ToolKit panel infomation			*/
    int     type;				/* ToolKit panel type				*/
    int     wx,wy,ww,wh;		/* ToolKit panel position & size	*/
    int     ix,iy,iw,ih;		/* ToolKit icon position & size		*/
	int		bw;					/* Toolkit panel border width		*/
    char  	*bg;				/* panel background pixel			*/
    char	*bd;				/* panel border pixel				*/
	Ktroot	*root;				/* root infomation address			*/
	QID		panel;				/* panel chain QUE id				*/
    Window  kit;				/* ourself window ID				*/
    Window  ico;				/* bitmap icon window ID			*/
    Window  par;				/* parent wiondow ID				*/
	Pixmap	draw;				/* Background Draw pixmap			*/
    Display *dis;				/* X server connection				*/
    int     scr;				/* X screen							*/
    Colormap cmap;				/* X Colormap						*/
    GC      gc;					/* X GC								*/
	int		ucid;				/* user define cursor id 			*/
	Cursor	cur;				/* cursor id						*/
	int		soc;				/* message socket desclipter		*/
    Pixmap  *ptn;				/* ToolKit pattern pixmap			*/
    Ktfinf  *fnt;				/* ToolKit Font infomation			*/
    unsigned int   mask;		/* pointer event button mask		*/
    QID     point;				/* curent pointer event				*/
    QID     move;				/* curent move event				*/
    CQcnt   child;				/* child panel ID chain				*/
    CQcnt   data;				/* display data chain				*/
    CQcnt   evpt;				/* pointer event chain				*/
    CQcnt   evmv;				/* move event chain					*/
	Ktobj	*wmov;				/* window move event				*/
	Kttitl	titl;				/* title bar infomation				*/
	int		stat;				/* panel status						*/
	int		mflg;				/* modal flag						*/
	int		*inf;				/* panel infomation					*/
	int 	*wbuf;				/* Wnn kanri buff					*/
    int     (*esub)();			/* Panel exit subroutine			*/
    int     (*msub)();			/* Panel mesage subroutine			*/
    int     (*psub)();			/* Panel event subroutine			*/
    int     (*ksub)();			/* Panel keyin subroutine			*/
    int     (*xsub)();			/* Panel X event subroutine			*/
	int		(*vsub)();			/* Panel viewable subroutine		*/
}   Ktcore;

typedef struct  {				/* panel chain queue data			*/
    CQhed   hed;				/* chain header						*/
    Ktcore	*core;				/* panel infomation address			*/
}   KtpanQ;

typedef struct  {				/* object chain queue data			*/
    CQhed   hed;				/* chain header						*/
    Ktobj   *obj;				/* object address					*/
}   KtobjQ;

typedef struct  {				/* child panel chain queque data	*/
    CQhed   hed;				/* chain header						*/
    Window  wid;				/* child panel window ID			*/
}   KtwidQ;

typedef struct	{				/* panel configration infomation	*/
	int		wx,wy;				/* panel position					*/
	int		ww,wh;				/* panel size						*/
	Window	above;				/* panel stack						*/
}	Ktconfig;

typedef	struct	{				/* label data						*/
	char	*label;				/* object label						*/
	Ktobj	*obj;				/* object address					*/
}	Ktlabel;

/*$*/

/*  ToolKit object infomation data  */

typedef struct  {				/* ToolKit open infomation			*/
	int		type;				/* panel type						*/
    int     wx,wy,ww,wh;		/* panel position & size			*/
	int		bw;					/* panel border wodth				*/
	int		fle,flt,fli;		/* title bar config flag			*/
    char    *apl;				/* application name					*/
    char    *title;				/* panel title						*/
    char    *isym;				/* bitmap icon bitmap file name		*/
    char    *bg,*bd,*tl;		/* panel back & border & title		*/
	int		cid;				/* panel cursor id					*/
}   Ktpanel;

typedef struct  {				/* ToolKit text object				*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* text mode						*/
    int     x,y;				/* text position					*/
    int     c,l;				/* text area size					*/
    char    *fc,*bc;			/* text fore & back color			*/
    int     font;				/* text font type					*/
    char    *text;				/* text stringth					*/
}   Kttext;

typedef struct  {				/* ToolKit scroll text object		*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* text mode						*/
    int     x,y;				/* text position					*/
    int     c,l;				/* text area size					*/
    char    *fc,*bc;			/* text fore & back color			*/
	char	*hc,*sc;			/* txet hight-light color			*/
    int     font;				/* text font type					*/
    char    *text;				/* text stringth					*/
	int		*inf;				/* infomation data					*/
}   Ktstext;

typedef struct  {				/* ToolKit repeat text data			*/
    int     mode;				/* text mode						*/
    char    *fc;				/* text fore color					*/
    char    *text;				/* text stringth					*/
}   Ktrtdt;

typedef struct  {				/* ToolKit repeat text object		*/
    Ktobj   hed;				/* object header					*/
    int     x,y;				/* repeat start position			*/
    int     dx,dy;				/* next positon delta				*/
    int     l;					/* repeat count						*/
    char    *bc;				/* text back color					*/
    int     font;				/* text font type					*/
    Ktrtdt  *tdat;				/* repeat text data address			*/
}   Ktrtxt;

typedef XPoint  Ktptdt;			/* ToolKit point data				*/

typedef	struct	{				/* Toolkit graph poit data			*/
	short	x;					/* point	x						*/
	short	y;					/* point	y						*/
	short	flg;				/* point draw flag					*/
}	Ktptgr;

typedef struct  {				/* ToolKit line object				*/
    Ktobj   hed;				/* object header					*/
	int		mode;				/* SEGMENTS MODE OR LINES MODE		*/
    int     func;				/* grphic function					*/
    int     pmode;				/* coor mode						*/
    int     ptn;				/* line pattern						*/
    char    *col;				/* line color						*/
    int     pc;					/* point count						*/
    Ktptdt  *pt;				/* line data address				*/
}   Ktline;

typedef	struct	{				/* stripe color structure			*/
	char	*col;				/* stripe color						*/
	int		w;					/* stripe width						*/
}			Ktcldt;

typedef struct  {				/* ToolKit line object				*/
    Ktobj   hed;				/* object header					*/
	int		lmode;				/* SEGMENTS MODE OR LINES MODE		*/
	int		x,y;				/* crip rectangle x,y				*/
	int		w,h;				/* crip rectangle width, height		*/
    int     amode;				/* coor mode						*/
    int     func;				/* grphic function					*/
    int     ptn;				/* line pattern						*/
	int		lw;					/* line width						*/
    int     pc;					/* point count						*/
    Ktptdt  *pt;				/* line data address				*/
	int		pmode;				/* paint mode						*/
	Ktcldt	*cldt;				/* stripe paint color				*/
	char	*fc;				/* solid color						*/
	char	*bc;				/* background color					*/
}   Ktgline;

typedef struct  {				/* ToolKit keisen object			*/
    Ktobj   hed;				/* object header					*/
    int     func;				/* graphic function					*/
    int     mode;				/* keisen mode						*/
    int     ptn;				/* line pattern						*/
    char    *col;				/* line color						*/
    int     x,y;				/* line initial position			*/
    int     len;				/* line length						*/
    int     lc;					/* line count						*/
    int     delta;				/* line kankaku						*/
}   Ktkei;

typedef struct  {				/* ToolKit rectangle object			*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* rect mode						*/
    int     x,y;				/* rect position					*/
    int     w,h;				/* rect size						*/
    int     wh;					/* rect waku haba					*/
    char    *c1,*c2,*c3;		/* rect colors						*/
}   Ktrect;

typedef struct  {				/* ToolKit arc object				*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* arc mode							*/
	int		type;				/* arc type							*/
    int     x,y;				/* arc position						*/
    int     w,h;				/* arc size							*/
    int     as,ae;				/* arc start angle, draw angle		*/
    char    *c1,*c2;			/* arc colors						*/
}   Ktarc;

typedef	struct	{				/* ToolKit polygon object			*/
	Ktobj	hed;				/* object header                    */
    int     mode;               /* polygon mode						*/
	int		func;				/* polygon draw graphic function	*/
	int		x,y;				/* polygon position					*/
	int		pc;					/* point data count					*/
	Ktptdt	*pt;				/* point data address				*/
	char	*c1,*c2;			/* polygon color					*/
}	Ktpoly;

typedef struct  {				/* ToolKit bar cursor object		*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* bar cursor mode					*/
    int     x,y,l;				/* cursor position & length			*/
    char    *col;				/* cursor color						*/
    int     font;				/* cursor symbol font type			*/
    char    *sym;				/* cursor symbol text stringth		*/
    int     flg;				/* cursor flag						*/
    int     ox,oy;				/* cursor old position				*/
}   Ktbarc;

typedef struct  {				/* ToolKit box cursor object		*/
    Ktobj   hed;				/* object header					*/
	int		mode;				/* box cursor mode					*/
    int     x,y;				/* cursor position					*/
    int     w,h;				/* cursor size						*/
    char    *col;				/* cursor color						*/
	char	*bak;				/* cursor back color				*/
    int     flg;				/* cursor flag						*/
    int     ox,oy;				/* cursor old position				*/
    int     ow,oh;				/* cursor old size					*/
}   Ktboxc;

typedef struct  {				/* ToolKit bar graph object 		*/
    Ktobj   hed;				/* object header					*/
	int		mode;				/* graph mode						*/
    int     x,y;				/* graph position					*/
    int     w,h;				/* graph size						*/
    char    *fc;				/* graph color						*/
	char	*bc;				/* graph back ground color			*/
	float	val;				/* graph data value	(0-100)			*/
    int     flg;				/* graph flag						*/
	int		old;				/* graph old data value				*/
}   Ktbarg;

typedef struct  {				/* ToolKit image data object		*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* image mode						*/
    int     x,y;				/* image position					*/
    int     w,h;				/* image size						*/
    char    *fc,*bc;			/* image fore & back color			*/
    char    *name;				/* image file name or data address	*/
    int     flg;				/* image flag						*/
    Pixmap  pix;				/* image pixmap						*/
}   Ktimag;

typedef struct  {				/* ToolKit raster data object		*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* raster mode						*/
    int     x,y;				/* raster position					*/
    int     w,h;				/* raster size						*/
    char    *name;				/* raster file name					*/
    int     flg;				/* raster flag						*/
	int		*info;				/* raster infomation data			*/
	QID		event;				/* raster event infomation			*/
}   Ktrast;

typedef	struct	{				/* ToolKit new rect object			*/
	Ktobj		hed;			/* Object header					*/
	int			mode;			/* Draw mode Frame & Paint			*/
	int			func;			/* Draw function					*/
	int			fw;				/* Frame width						*/
	int			dash;			/* Frame dash type					*/
	int			fmode;			/* Frame paint mode					*/
	char		*ff,*fb;		/* Frame paint for & back color		*/
	int			tile;			/* Tiling style						*/
	int			ptn;			/* Fix tile pattern no				*/
	char		*bit;			/* User tile pattern data			*/
	int			bw,bh;			/* User tile pattern size			*/
	int			pmode;			/* Paint mode						*/
	char		*pf,*pb;		/* Paint for & back color			*/
	int			x,y;			/* Rectangle position x & y			*/
	int			w,h;			/* Rectangle size width & height	*/
}	Ktnrect;

typedef	struct	{				/* ToolKit new arc object			*/
	Ktobj		hed;			/* Object header					*/
	int			mode;			/* Draw mode Frame & Paint			*/
	int			func;			/* Draw function					*/
	int			fw;				/* Frame width						*/
	int			dash;			/* Frame dash type					*/
	int			fmode;			/* Frame paint mode					*/
	char		*ff,*fb;		/* Frame paint for & back color		*/
	int			tile;			/* Tiling style						*/
	int			ptn;			/* Fix tile pattern no				*/
	char		*bit;			/* User tile pattern data			*/
	int			bw,bh;			/* User tile pattern size			*/
	int			pmode;			/* Paint mode						*/
	char		*pf,*pb;		/* Paint for & back color			*/
	int			amode;			/* Arc draw style					*/
	int			x,y;			/* Arc position x & y				*/
	int			w,h;			/* Arc size width & height			*/
	int			as,ae;			/* Arc draw angle					*/
}	Ktnarc;

typedef	struct	{				/* ToolKit new polygon object		*/
	Ktobj		hed;			/* Object header					*/
	int			mode;			/* Draw mode Frame & Paint			*/
	int			func;			/* Draw function					*/
	int			fw;				/* Frame width						*/
	int			dash;			/* Frame dash type					*/
	int			fmode;			/* Frame paint mode					*/
	char		*ff,*fb;		/* Frame paint for & back color		*/
	int			tile;			/* Tiling style						*/
	int			ptn;			/* Fix tile pattern no				*/
	char		*bit;			/* User tile pattern data			*/
	int			bw,bh;			/* User tile pattern size			*/
	int			pmode;			/* Paint mode						*/
	char		*pf,*pb;		/* Paint for & back color			*/
	int			x,y;			/* Polygon base point x & y			*/
	int			pc;				/* Polygon point count				*/
	Ktptdt		*pt;			/* Polygon point data				*/
}	Ktnpoly;

typedef	struct	{				/* Toolkit canvas object			*/
	Ktobj	hed;				/* object header					*/
	int		mode;				/* canvas mode						*/
	int		x,y;				/* canvas position					*/
	int		w,h;				/* canvas view size					*/
	int		wh;					/* canvas frame width				*/
	int		cw,ch;				/* canvas size						*/
	int		dx,dy;				/* canvas view position				*/
	char	*cc;				/* canvas color						*/
	char	*pc;				/* canvas frame color				*/
	char	*hc,*bc;			/* canvas heigh-light color			*/
	int		*inf;				/* canvas control data				*/
}	Ktcanv;

typedef struct  {				/* ToolKit mark object				*/
    Ktobj   hed;				/* object header					*/
	int		type;				/* mark type						*/
    int     mode;				/* mark mode						*/
    int     x,y;				/* mark position					*/
    int     w,h;				/* mark size						*/
    char    *cl;				/* mark colors						*/
}   Ktmark;

typedef struct  {				/* ToolKit button object			*/
    Ktobj   hed;				/* object header                    */
    int     mode;				/* button mode						*/
    int     x,y;				/* button position					*/
    int     w,h;				/* button size						*/
    int     wh;					/* button waku haba					*/
    int     font;				/* button symbol font type			*/
    char    *sym;				/* button synbol stringth			*/
    char    *pc1,*pc2;			/* button panel color 1,2			*/
    char    *hc1,*hc2;			/* button waku color 1,2			*/
    char    *sc1,*sc2;			/* button symbol color 1,2			*/
    int     bid;				/* button user id					*/
    int     (*subon)();			/* button callback sub ( on )		*/
    int     (*suboff)();		/* button callback sub ( off )		*/
    int     flg;				/* button flag						*/
	Pixmap	pix;				/* symbol image pixmap (imagesymbol)*/
    QID     event;				/* event infomation	id				*/
}   Ktbutn;

typedef struct  {				/* ToolKit scrollbar object			*/
    Ktobj   hed;				/* object header                    */
    int     mode;				/* scrollbar mode					*/
    int     x,y;				/* scrollbar position				*/
    int     w,h;				/* scrollbar size					*/
    int     bl;					/* scrollbar bar length (%)			*/
	char	*pc;				/* scrollbar back panel color       */
    char    *bc;				/* scrollbar bar color				*/
    char    *hc1,*hc2;			/* scrollbar highlight color		*/
    int     (*sub)();			/* scrollbar callback sub			*/
    int     bp;					/* scrollbar bar position (%)		*/
    QID     event;				/* event infomation id				*/
}   Ktsbar;

typedef struct  {				/* ToolKit scrollbar object			*/
    Ktobj   hed;				/* object header                    */
    int     mode;				/* mode								*/
    int     x,y;				/* position							*/
    int     l;					/* size								*/
	int     dm;					/* scroll data max value			*/
	int     dw;					/* scroll data width move value		*/
	int     ds;					/* scroll data short move value		*/
	int     dp;					/* scroll data point				*/
	char    *bc;				/* scrollbar bar color				*/
	char    *hc1,*hc2;			/* scrollbar highlight color		*/
	int		id;					/* scrollbar user id				*/
    int     (*sub)();			/* scrollbar callback sub			*/
	int     bp;					/* elevator position				*/
    QID     event;				/* event infomation id				*/
}	Ktosbar;

typedef struct  {				/* ToolKit input object				*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* input mode						*/
    int     x,y;				/* input area position				*/
    int     len;				/* input area length (moji)			*/
    int     font;				/* input text font type				*/
    char    *buff;				/* input text buffer address		*/
    char    *fc,*bc;			/* input text fore & back color		*/
	int		id;					/* input usr id						*/
    int     (*subb)();			/* input before callback sub		*/
    int     (*sube)();			/* input end callback sub			*/
    int     flg;				/* input flag						*/
    QID     event;				/* event infomation id				*/
}   Ktinput;

typedef struct  {				/* ToolKit input object				*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* input mode						*/
    int     x,y;				/* input area position				*/
    int     c,l;				/* input area colum & line 			*/
    char    *fc,*bc;			/* input text fore & back color		*/
    int     font;				/* input text font type				*/
    char    *text;				/* input text buffer address		*/
	int		id;					/* input usr id						*/
    int     (*subb)();			/* input before callback sub		*/
    int     (*sube)();			/* input end callback sub			*/
    int     flg;				/* input flag						*/
    QID     event;				/* event infomation id				*/
}   Ktitext;

typedef struct  {				/* ToolKit new input text object	*/
    Ktobj   hed;				/* object header					*/
    int     mode;				/* input mode						*/
    int     x,y;				/* input area position				*/
    int     c,l;				/* input area colum & line 			*/
    int     mc,ml;				/* input area max colum & line 		*/
    int     font;				/* input text font type				*/
    char    *text;				/* input text buffer address		*/
	int		size;				/* input text buffer size			*/
    char    *fc,*bc;			/* input text fore & back color		*/
	char	*pc;				/* input text frame color			*/
	char	*hc,*sc;			/* input txet hight-light color		*/
	int		id;					/* input usr id						*/
    int     (*subb)();			/* input before callback sub		*/
    int     (*sube)();			/* input end callback sub			*/
    int     flg;				/* input flag						*/
	int		*inf;				/* lib infomation					*/
    QID     event;				/* event infomation id				*/
}   Ktntext;

typedef struct  {				/* ToolKit pointer object			*/
    Ktobj   hed;				/* object header                    */
    int     butn;				/* mouse button mask				*/
    int     x,y;				/* event catch area position		*/
    int     w,h;				/* event catch area size			*/
    int     pid;				/* pointer user id					*/
    int     (*sub)();			/* pointer callback sub				*/
    QID     event;				/* event infomation id				*/
}   Ktpoit;

typedef struct  {				/* ToolKit move object				*/
    Ktobj   hed;				/* object header                    */
    int     mask;				/* mouse button mask                */
    int     x,y;				/* move catch area position			*/
    int     w,h;				/* move catch area size				*/
    int     (*sub)();			/* move callback sub				*/
    QID     event;				/* event infomation id				*/
}   Ktmove;

typedef	struct	{				/* Toolkit menu object				*/
	Ktobj	hed;				/* object header					*/
	int		mask;				/* menu button mask					*/
	int		x,y;				/* menu display area position		*/
	int		w,h;				/* menu display area sive			*/
	int		mw,mh;				/* menu size						*/
	int		tfont;				/* menu title font type				*/
	char	*ttext;				/* menu title strings				*/
	int		ifont;				/* menu item font type				*/
	char	**itext;			/* menu item stringts table address	*/
	int		iw,ih;				/* bitmap item size					*/
	char	*mc,*tc,*ic;		/* menu color back,title,item		*/
	int		(*sub)();			/* menu callback subroutine			*/
	int		flg;				/* menu flag						*/
	QID		event;				/* menu event infomation id			*/
}	Ktmenu;

typedef	struct	{				/* Toolkit combination object		*/
	Ktobj	hed;				/* object header					*/
	int		x,y;				/* object offset x,y position		*/
	Ktobj	**obj;				/* combination object tree			*/
	Ktcore	*core;
}	Ktcomb;

typedef	struct	{				/* Toolkit table clum config		*/
	int		clum;				/* use line							*/
	int		font;				/* title font						*/
	char	*titl;				/* title stringth					*/
	char	*col;				/* title color						*/
	int		posi;				/* title position					*/
}	Ktcset;

typedef	struct	{				/* Toolkit table line config		*/
	int		line;				/* use clum							*/
	int		font;				/* title font						*/
	char	*titl;				/* title stringth					*/
	char	*col;				/* title color						*/
	int		posi;				/* title position					*/
}	Ktlset;

typedef	struct	{				/* Toolkit table data config		*/
	int		mode;				/* data mode						*/
	int		clum;				/* data display character length	*/
	int		font;				/* data display font				*/
	char	*col;				/* data display color				*/
	int		posi;				/* data display position			*/
	int		type;				/* data type						*/
	int		prec;				/* data precision					*/
	int		*data;				/* data address						*/
}	Ktdset;

typedef	struct	{				/* Toolkit table object				*/
	Ktobj	hed;				/* object header					*/
	int		x,y;				/* table position					*/
	int		mw,mh;				/* table matrix size				*/
	int		vw,vh;				/* table view size (matrix count)	*/
	int		ctc;				/* clum title use line				*/
	int		ltc;				/* line title use clum				*/
	char	*pc,*tc,*bc,*vc,*hc;/* table color						*/
	int		vp,hp;				/* keisen pattern					*/
	Ktcset	*cset;				/* clum config address				*/
	Ktlset	*lset;				/* line config address				*/
	Ktdset	*dset;				/* data config address				*/
    int     (*subb)();			/* input before callback sub		*/
    int     (*sube)();			/* input end callback sub			*/
	int		*inf;				/* table infomation data			*/
}	Kttable;

typedef	struct	{					/* Toolkit data input object	*/
	Ktobj	hed;					/* object header				*/
	int		mode;					/* input mode (KION,KIOFF)		*/
	int		x,y;					/* input area position			*/
	int		w,h;					/* input area size				*/
	int		c;						/* input text charactoer length	*/
	int		font;					/* text font					*/
	char	*fc,*bc;				/* fore & back color			*/
	char	*hc,*sc;				/* hilight color				*/
	int		posi;					/* data display position		*/
	int		type;					/* data type					*/
	int		prec;					/* data precision				*/
	int		*data;					/* data address					*/
	int		id;						/* object id					*/
	int		(*subb)();				/* before call back sub			*/
	int		(*sube)();				/* input call back sub			*/
	int		flg;					/* input flag					*/
	int		*inf;					/* lib infomation				*/
	QID		event;					/* lib event infomation			*/
}	Ktidata;

typedef struct	{				/* Toolkit menu item define			*/
	int		type;				/* item type						*/
	char	*sc;				/* item color						*/
	char	*sym;				/* item symbol						*/
	char	*pane;				/* sub menu panel define			*/
	int		id;					/* item user id						*/
	int		flg;				/* item flag						*/
}	Ktmitem;

typedef	struct	{				/* Toolkit menu panel define		*/
	int		w,h;				/* menu panel size					*/
	char	*pc;				/* menu panel color					*/
	char	*hc,*bc;			/* menu height light color			*/
	int		font;				/* menu text font					*/
	char	*titl;				/* menu title text					*/
	Ktmitem	*item;				/* menu item define data			*/
}	Ktmpane;

typedef	struct	{				/* toolkit new menu object			*/
	Ktobj	hed;				/* object header					*/
	int		mode;				/* menu mode						*/
	int		mask;				/* menu select button mask			*/
	int		x,y;				/* menu area position				*/
	int		w,h;				/* menu area size					*/
	int		wh;					/* menu button hight				*/
	int		font;				/* menu button symbol symbol		*/
	char	*sym;				/*    //       symbol addr			*/
	char	*pc;				/*    //       color				*/
	char	*sc;				/*    //	   symbol color			*/
	char	*hc,*bc;			/*    //       heigh light color	*/
	Ktmpane	*pane;				/* menu panel define				*/
	int		id;					/* menu user define id				*/
	int		(*subb)();			/* before call back					*/
	int		(*sube)();			/* after call back					*/
	int		flg;				/* menu flag						*/
	int		*inf;				/* menu controll data				*/
	QID		event;				/* event infomation					*/
}	Ktnmenu;

typedef struct	{				/* toolkit list object				*/
	char	*sym;				/* item symbol						*/
	char	*fc,*bc;			/* item fore & back color			*/
	char	*sfc,*sbc;			/* select item fore & back color	*/
	int		sel;				/* item select flag					*/
	int		id;					/* item user id						*/
}	Ktlitem;

typedef struct	{				/* toolkit list object				*/
	Ktobj	hed;				/* object header					*/
	int		mode;				/* list mode						*/
	int		x,y;				/* list	area position				*/
	int		w,h;				/* list area size					*/
	int		hl;					/* display area item count			*/
	int		wh;					/* list waku haba					*/
	int		th;					/* list title takasa				*/
	int		arow;				/* list retu count					*/
	int		ds;					/* select item display type			*/
	int		posi;				/* list item text display position	*/
	int		tfont;				/* list title text font				*/
	char	*title;				/* list title text					*/
	int		ifont;				/* list item text font				*/
	Ktlitem	*item;				/* list item define data			*/
	int		stl;				/* start item position				*/
	char	*pc;				/* list scrollbar color				*/
	char	*hc,*sc;			/* list	height light color			*/
	char	*lc;				/* list back color					*/
	char	*kc;				/* list keisen color				*/
	char	*tc;				/* list title color					*/
	char	*tbc;				/* list title back color			*/
	int		id;					/* list user define id				*/
	int		(*sub)();			/* call back (move,on,off)			*/
	int		*inf;				/* list controll data				*/
	QID		event;				/* event information				*/
}	Ktlist;

typedef	struct	{				/* Toolkit new data input object	*/
	Ktobj	hed;				/* object header					*/
	int		mode;				/* ndata mode						*/
	int		x,y;				/* ndata area position				*/
	int		w,h;				/* ndata area size					*/
	int		c;					/* ndata text charactoer length		*/
	int		font;				/* text font						*/
	char	*fc,*bc;			/* fore & back color				*/
	char	*hc,*sc;			/* hilight color					*/
	int		type;				/* data type						*/
	int		iposi;				/* before data display position		*/
	int		posi;				/* end data display position		*/
	int		iattr;				/* before data display attribute	*/
	int		attr;				/* end data display attribute		*/
	int		zero;				/* zero suppress					*/
	int		cposi;				/* cursor position					*/
	int		ctype;				/* cursor type						*/
	int		prec;				/* data precision					*/
	int		*data;				/* data address						*/
	int		id;					/* object id						*/
	int		(*subb)();			/* before call back sub				*/
	int		(*sube)();			/* end call back sub				*/
	int		flg;				/* ndata flag						*/
	int		*inf;				/* lib information					*/
	QID		event;				/* lib event information			*/
}	Ktdata2;

typedef struct	{				/* Toolkit table data config		*/
	int		dmode;				/* data mode						*/
	int		clum;				/* data display character length	*/
	int		line;				/* data display line count			*/
	int		font;				/* data display font				*/
	char	*col;				/* data display color				*/
	char	*bcol;				/* data display back color			*/
	int		posi;				/* data display position(right,left)*/
	int		posi2;				/* data display position(up,down)	*/
	int		type;				/* data type						*/
	int		prec;				/* data precision					*/
	int		limit;				/* limit check mode					*/
	double	max;				/* maximum limit value				*/
	double	min;				/* minimum limit value				*/
	int		idec;				/* decision character count			*/
	int		hmd;				/* cell modify						*/
    int     sp;                 /* cell horizonal/slat line pattern */
	char	*hmdc;				/* cell modify color				*/
	int		imod;				/* cursor mode						*/
	int		cx;					/* cursor position x				*/
	int		cy;					/* cursor position y				*/
	char	*chk;				/* input kanou moji					*/
	char	*fmd;				/* display format					*/
	int		next;				/* next input cell type				*/
	int		ncell;				/* next input cell line				*/
	int		ncelc;				/* next input cell clum				*/
	int		bcell;				/* before input cell line			*/
	int		bcelc;				/* before input cell clum			*/
	int		rjoin;				/* right cell joint					*/
	int		djoin;				/* under cell joint					*/
	int		vp;					/* vertical line pattern			*/
	int		hp;					/* horizontal line pattern			*/
	char	*vc;				/* vertical line color				*/
	char	*hc;				/* horizontal line color			*/
	int		*data;				/* data address						*/
	int		cinf;				/* joint information				*/
}	Ktdtset;
 
typedef struct	{				/* Toolkit table object				*/
	Ktobj	hed;				/* object header					*/
	int		x,y;				/* table position					*/
	int		wh;					/* table waku haba					*/
	int		mw,mh;				/* table matrix size				*/
	int		vw,vh;				/* table view size (matrix count)	*/
	int		*cwd;				/* clum cell wide data table address*/
	int		*lhd;				/* line cell high data table address*/
	int		ctl;				/* fix clum title line count		*/
	int		ltc;				/* fix line title clum count		*/
	int		mctl;				/* move clum title line count		*/
	int		mltc;				/* move line title clum count		*/
	int		stal;				/* display start cell line			*/
	int		stac;				/* display start cell clum			*/
	char	*tc,*bc;			/* table shadow color				*/
	char	*sc;				/* table scroll color				*/
	Ktdtset	*dtset;				/* cell config address				*/
	char	*dtype;				/* data access type					*/
	int		(*subs)();			/* scroll bar callback sub			*/
	int		(*subb)();			/* input before callback sub		*/
	int		(*sube)();			/* input end callback sub			*/
	int		*inf;				/* table infomation data			*/
}	Kttable2;

typedef	struct	{				/* Toolkit data3 object				*/
	Ktobj	hed;				/* object header					*/
	int		mode;				/* ndata mode						*/
	int		x,y;				/* ndata area position				*/
	int		w,h;				/* ndata area size					*/
	int		c;					/* ndata text charactoer length		*/
	int		line;				/* ndata text line length			*/
	int		font;				/* text font						*/
	char	*fc,*bc;			/* fore & back color				*/
	char	*hc,*sc;			/* hilight color					*/
	int		posi;				/* data display position(right,left)*/
	int		posi2;				/* data display position(up,down)	*/
	int		type;				/* data type						*/
	int		prec;				/* data precision					*/
	int		limit;				/* limit check mode					*/
	double	max;				/* max limit						*/
	double	min;				/* min limit						*/
	int		idec;				/* kakutei moji count				*/
	int		hmd;				/* cell modify						*/
    int     sp;                 /* cell horizonal/slat line pattern */
	char	*hmdc;				/* cell modify color				*/
	int		imod;				/* cursor mode						*/
	int		cx;					/* cursor position x				*/
	int		cy;					/* cursor position y				*/
	char	*chk;				/* input kanou moji					*/
	char	*fmt;				/* display format					*/
	int		*data;				/* data address						*/
	int		id;					/* object id						*/
	int		(*subb)();			/* before call back sub				*/
	int		(*sube)();			/* end call back sub				*/
	int		flg;				/* ndata flag						*/
	int		*inf;				/* lib information					*/
	QID		event;				/* lib event information			*/
}	Ktdata3;

#endif
